<?php

namespace App\Classes\Modules\AddressBook\DataTransferObjects;


class AddressBookObject
{
    /** @var int|null */
    private $type;

    /** @var int|null */
    private $referenceId;

    /** @var string|null */
    private $name;

    /** @var string|null */
    private $phoneNumber;

    /** @var string|null */
    private $streetOne;

    /** @var string|null */
    private $streetTwo;

    /** @var string|null */
    private $city;

    /** @var string|null */
    private $state;

    /** @var string|null */
    private $postCode;

    /** @var string|null */
    private $country;

    /** @var boolean */
    private $isDefault;

    /** @var boolean */
    private $isBilling;

    /**
     * AddressBookObject constructor.
     * @param int|null $type
     * @param int|null $referenceId
     * @param null|string $name
     * @param null|string $phoneNumber
     * @param null|string $streetOne
     * @param null|string $streetTwo
     * @param null|string $city
     * @param null|string $state
     * @param null|string $postCode
     * @param null|string $country
     * @param bool $isDefault
     * @param bool $isBilling
     */
    public function __construct(?int $type, ?int $referenceId, ?string $name, ?string $phoneNumber, ?string $streetOne, ?string $streetTwo, ?string $city, ?string $state, ?string $postCode, ?string $country, bool $isDefault, bool $isBilling)
    {
        $this->type = $type;
        $this->referenceId = $referenceId;
        $this->name = $name;
        $this->phoneNumber = $phoneNumber;
        $this->streetOne = $streetOne;
        $this->streetTwo = $streetTwo;
        $this->city = $city;
        $this->state = $state;
        $this->postCode = $postCode;
        $this->country = $country;
        $this->isDefault = $isDefault;
        $this->isBilling = $isBilling;
    }

    /**
     * @return int|null
     */
    public function getType(): ?int
    {
        return $this->type;
    }

    /**
     * @return int|null
     */
    public function getReferenceId(): ?int
    {
        return $this->referenceId;
    }

    /**
     * @return null|string
     */
    public function getName(): ?string
    {
        return $this->name;
    }

    /**
     * @return null|string
     */
    public function getPhoneNumber(): ?string
    {
        return $this->phoneNumber;
    }

    /**
     * @return null|string
     */
    public function getStreetOne(): ?string
    {
        return $this->streetOne;
    }

    /**
     * @return null|string
     */
    public function getStreetTwo(): ?string
    {
        return $this->streetTwo;
    }

    /**
     * @return null|string
     */
    public function getCity(): ?string
    {
        return $this->city;
    }

    /**
     * @return null|string
     */
    public function getState(): ?string
    {
        return $this->state;
    }

    /**
     * @return null|string
     */
    public function getPostCode(): ?string
    {
        return $this->postCode;
    }

    /**
     * @return null|string
     */
    public function getCountry(): ?string
    {
        return $this->country;
    }

    /**
     * @return bool
     */
    public function isDefault(): bool
    {
        return $this->isDefault;
    }

    /**
     * @return bool
     */
    public function isBilling(): bool
    {
        return $this->isBilling;
    }


}